%MACRO CUSP1;
%LET D=0.1;
%macro winCUSP1;
DATA _NULL_;
WINDOW MCUSP1 COLOR=GRAY
#1 "CONTENT UNIFORMITY ACCEPTANCE LIMIT PROGRAM" C=yellow
#2 "FOR SAMPLING PLAN 1 (ONE SAMPLE PER LOCATION)" C=yellow
#4  "ENTER DOSAGE FORM (TABLET OR CAPSULE):  " C=BLUE FORM  $7.
     A=UNDERLINE
#5  "ENTER SAMPLE SIZE:  " C=BLUE NUMBER 4.0 A=UNDERLINE
#7  "ENTER BOUND ON FUTURE PERCENTAGE PASSING (50.0-99.0):  "
     C=BLUE LBOUND 4.1 A=UNDERLINE
#8  "ENTER CONFIDENCE LEVEL (50.0-99.0):  " C=BLUE CILEVEL 4.1
     A=UNDERLINE
#10 "DO YOU WANT TO PRINT THE ACCEPTANCE LIMIT TABLE?" C=BLUE
#11 "ENTER Y OR N ="  C=BLUE A1CUSP1 $1.
#13 "DO YOU WANT TO EVALUATE THE ACCEPTANCE LIMIT TABLE?" C=BLUE
#14 "ENTER Y OR N ="  C=BLUE A2CUSP1 $1.
#16 "DO YOU WANT THE LOWER BOUND FOR A SPECIFIC SAMPLE RESULT?"
    C=BLUE
#17 "ENTER Y OR N ="  C=BLUE A3CUSP1 $1.;
WINDOW DOSCUSP1 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "DOSAGE FORM MUST BE CAPSULE OR TABLET" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW SCUSP1 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "SAMPLE SIZE MUST BE AN INTEGER GREATER THAN 4" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW BCUSP1 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "THE LOWER BOUND ON THE PERCENTAGE OF ALL FUTURE BATCHES" C=YELLOW
#2 "PASSING THE USP TEST MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#3 "(TYPICAL VALUES ARE 50.0 AND 95.0)" C=YELLOW
#5 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW CICUSP1 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "CONFIDENCE INTERVAL VALUES MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#2 "(TYPICAL VALUES ARE 90.0, 95.0, OR 99.0)" C=YELLOW
#4 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ANSCUSP1 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "REQUESTS REQUIRE A RESPONSE OF: Y OR N" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
FORM='CAPSULE';
NUMBER=30;
LBOUND = 95;
CILEVEL = 95;
A1CUSP1 = 'Y';
A2CUSP1 = 'N';
A3CUSP1 = 'N';
MAINCU1:
DISPLAY MCUSP1 BELL;
IF FORM NE 'CAPSULE' AND FORM NE 'TABLET' THEN DO;
DISPLAY DOSCUSP1 BELL;
GOTO MAINCU1;
END;
IF NUMBER  LE 4 OR NUMBER NE ROUND(NUMBER) THEN DO;
DISPLAY SCUSP1 BELL;
GOTO MAINCU1;
END;
IF LBOUND GT 99.0 OR LBOUND LT 50.0 THEN DO;
DISPLAY BCUSP1 BELL;
GOTO MAINCU1;
END;
IF CILEVEL GT 99.0 OR CILEVEL LT 50.0 THEN DO;
DISPLAY CICUSP1 BELL;
GOTO MAINCU1;
END;
IF A1CUSP1 NE 'Y' AND A1CUSP1 NE 'N' AND A1CUSP1 NE 'y' AND
   A1CUSP1 NE 'n' THEN DO;
DISPLAY ANSCUSP1 BELL;
GOTO MAINCU1;
END;
IF A2CUSP1 NE 'Y' AND A2CUSP1 NE 'N' AND A2CUSP1 NE 'y' AND
   A2CUSP1 NE 'n' THEN DO;
DISPLAY ANSCUSP1 BELL;
GOTO MAINCU1;
END;
IF A3CUSP1 NE 'Y' AND A3CUSP1 NE 'N' AND A3CUSP1 NE 'y' AND
   A3CUSP1 NE 'n' THEN DO;
DISPLAY ANSCUSP1 BELL;
GOTO MAINCU1;
END;

CALL SYMPUT("A1CUSP1",PUT(UPCASE(A1CUSP1),$1.));
CALL SYMPUT("A2CUSP1",PUT(UPCASE(A2CUSP1),$1.));
CALL SYMPUT("A3CUSP1",PUT(UPCASE(A3CUSP1),$1.));
CALL SYMPUT("NUMBER",PUT(NUMBER,4.0));
CALL SYMPUT("LBOUND",PUT(LBOUND,4.1));
CALL SYMPUT("FORM",PUT(UPCASE(FORM),$7.));
CALL SYMPUT("CILEVEL",PUT(CILEVEL,4.1)); STOP;
RUN;
%mend winCUSP1;
%macro c1calc;
   C2 = 0.078;
   K = 1 + 30 * LLU * LLU / (SIGMA * SIGMA);
   V = K * K / (1 + 2 * 30 * LLU * LLU / (SIGMA * SIGMA));
   PCV2 = 1 - PROBF(30 / (K * C2 * C2), V, 29, 0.0);
   P1L = PROBNORM((100 - LLU) / SIGMA) - PROBNORM((85 - LLU) / SIGMA);
   P1U = PROBNORM((115 - LLU) / SIGMA) - PROBNORM((100 - LLU) / SIGMA);
   P1 = P1L + P1U;
   P2L = PROBNORM((85 - LLU) / SIGMA) - PROBNORM((75 - LLU) / SIGMA);
   P2U = PROBNORM((125 - LLU) / SIGMA) - PROBNORM((115 - LLU) / SIGMA);
   P2 = P2L + P2U;
     IF TYPE = 'T' THEN
   PCTTAB2 = P1 ** 30 + 30 * P1 ** 29 * P2;
     ELSE  IF TYPE = 'C' THEN
   PCTTAB2 = P1 ** 27 * (P1*P1*P1 + 30*P1*P1*P2 + 435*P1*P2*P2
             + 4060*P2*P2*P2);
   LPROB2 = MAX(PCV2 + PCTTAB2 - 1, 0);
   C1 = 0.060;
   K = 1 + 10 * LLU * LLU / (SIGMA * SIGMA);
   V = K * K / (1 + 2 * 10 * LLU * LLU / (SIGMA * SIGMA));
   PCV1 = 1 - PROBF(10 / (K * C1 * C1), V, 9, 0.0);
     IF TYPE = 'T' THEN
   PCTTAB1 = P1 ** 10;
     ELSE IF TYPE = 'C' THEN
   PCTTAB1 = P1 ** 9 * (P1 + 10*P2);
   LPROB1 = MAX(PCV1 + PCTTAB1 - 1,0);
   OVERLBD = MAX(LPROB1,LPROB2);
   C2 = 0.078;
   K = 1 + 30 * ULU * ULU / (SIGMA * SIGMA);
   V = K * K / (1 + 2 * 30 * ULU * ULU / (SIGMA * SIGMA));
   PCV2 = 1 - PROBF(30 / (K * C2 * C2), V, 29, 0.0);
   P1L = PROBNORM((100 - ULU) / SIGMA) - PROBNORM((85 - ULU) / SIGMA);
   P1U = PROBNORM((115 - ULU) / SIGMA) - PROBNORM((100 - ULU) / SIGMA);
   P1 = P1L + P1U;
   P2L = PROBNORM((85 - ULU) / SIGMA) - PROBNORM((75 - ULU) / SIGMA);
   P2U = PROBNORM((125 - ULU) / SIGMA) - PROBNORM((115 - ULU) / SIGMA);
   P2 = P2L + P2U;
     IF TYPE = 'T' THEN
   PCTTAB2 = P1 ** 30 + 30 * P1 ** 29 * P2;
     ELSE  IF TYPE = 'C' THEN
   PCTTAB2 = P1 ** 27 * (P1*P1*P1 + 30*P1*P1*P2 + 435*P1*P2*P2
             + 4060*P2*P2*P2);
   LPROB2 = MAX(PCV2 + PCTTAB2 - 1, 0);
   C1 = 0.060;
   K = 1 + 10 * ULU * ULU / (SIGMA * SIGMA);
   V = K * K / (1 + 2 * 10 * ULU * ULU / (SIGMA * SIGMA));
   PCV1 = 1 - PROBF(10 / (K * C1 * C1), V, 9, 0.0);
     IF TYPE = 'T' THEN
   PCTTAB1 = P1 ** 10;
     ELSE IF TYPE = 'C' THEN
   PCTTAB1 = P1 ** 9 * (P1 + 10*P2);
   LPROB1 = MAX(PCV1 + PCTTAB1 - 1,0);
   OVERUBD = MAX(LPROB1,LPROB2);
   OVERBD = MIN(OVERLBD, OVERUBD);
%mend c1calc;
%MACRO CALCUSP1;
DATA TAB;
LENGTH TYPE $1;
LABEL OVERBD = 'OVERALL LOWER BOUND'
       MEAN = 'SAMPLE MEAN(%CLAIM)';
   TYPE = "&FORM";
   D=&D;
   Z = PROBIT((1 + SQRT(&CILEVEL / 100)) / 2);
   N = &NUMBER;
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
   SDOLD = 0;
   STARTSD = 0.01;
   DO MEAN = 85.1 TO 114.9 BY D;
      BEGIN = STARTSD;
    DO SAMPSD = BEGIN TO 7.8 BY 0.001;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEAN - Z *SIGMA / SQRT(N);
    ULU = MEAN + Z * SIGMA / SQRT(N);
%c1calc
   IF OVERBD < &LBOUND/100 AND SAMPSD <= 0.0101 THEN DO;
   CV = 0; OUTPUT; SAMPSD = 20.0; GOTO NEXTT; END;
   IF OVERBD < &LBOUND/100 THEN DO;
      SAMPSD = SAMPSD - 0.001;
      IF SAMPSD < SDOLD THEN DO;
         STARTM = MEAN;
         GOTO UPPER;
          END;
      SDOLD = SAMPSD;
      STARTSD = SAMPSD;
      CV = 100 * SAMPSD / MEAN;
       OUTPUT;
       SAMPSD = 20.0;
       END;
    NEXTT:
     END;
    END;
    GOTO FINISH;
    UPPER:
          STARTSD = 0.01;

   DO MEAN = 114.9 TO STARTM BY -D;
    DO SAMPSD = STARTSD TO 7.8 BY 0.001;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEAN - Z *SIGMA / SQRT(N);
    ULU = MEAN + Z * SIGMA / SQRT(N);
%c1calc
   IF OVERBD < &LBOUND/100 AND SAMPSD <= 0.0101 THEN DO;
   CV = 0; OUTPUT; SAMPSD = 20.0; GOTO NEXTB; END;
   IF OVERBD < &LBOUND/100 THEN DO;
      SAMPSD = SAMPSD - 0.001;
      STARTSD = SAMPSD;
      CV = 100 * SAMPSD / MEAN;
       OUTPUT;
       SAMPSD = 20.0;
       END;
    NEXTB:
     END;
    END;
  FINISH:
  KEEP CV MEAN;
PROC SORT DATA=TAB; BY MEAN;
DATA
     ONE(RENAME = (MEAN = X1 CV = CV1))
     TWO(RENAME = (MEAN = X2 CV = CV2))
     THREE(RENAME = (MEAN = X3 CV = CV3))
     FOUR(RENAME = (MEAN = X4 CV = CV4))
     FIVE(RENAME = (MEAN = X5 CV = CV5))
     SIX(RENAME = (MEAN = X6 CV = CV6));
 SET TAB;
 IF MEAN <= 90.05 THEN OUTPUT ONE;
 IF 90.05 < MEAN <=  95.05 THEN OUTPUT TWO;
 IF 95.05   < MEAN <= 100.05  THEN OUTPUT THREE;
 IF 100.05  < MEAN <= 105.05  THEN OUTPUT FOUR;
 IF 105.05  < MEAN <= 110.05  THEN OUTPUT FIVE;
 IF 110.05  < MEAN <= 115.0  THEN OUTPUT SIX;
DATA SEVEN;
   MERGE ONE TWO THREE FOUR FIVE SIX;
RUN;
%MEND CALCUSP1;

%MACRO PRTCUSP1;
OPTIONS MISSING = ' ' NODATE NONUMBER;
OPTIONS LS=132;
PROC PRINT DATA=SEVEN SPLIT = '*';
   FORMAT CV1 CV2 CV3 CV4 CV5 CV6 5.2;
   LABEL
         X1 = '  MEAN*(% CLAIM)'
         X2 = '  MEAN*(% CLAIM)'
         X3 = '  MEAN*(% CLAIM)'
         X4 = '  MEAN*(% CLAIM)'
         X5 = '  MEAN*(% CLAIM)'
         X6 = '  MEAN*(% CLAIM)'
         CV1 = 'CV*(%)'
         CV2 = 'CV*(%)'
         CV3 = 'CV*(%)'
         CV4 = 'CV*(%)'
         CV5 = 'CV*(%)'
         CV6 = 'CV*(%)';
      VAR CV1 X2 CV2 X3 CV3 X4 CV4 X5 CV5 X6 CV6;
      ID X1;
TITLE1 "ACCEPTANCE LIMITS FOR &FORM CONTENT UNIFORMITY(N=&NUMBER)";
TITLE2 "SAMPLING PLAN 1";
TITLE3 "(MEETING LIMITS GUARANTEES, WITH &CILEVEL.% ASSURANCE, THAT AT LEAST";
TITLE4 "&LBOUND.% OF SAMPLES TESTED FOR CONTENT UNIFORMITY WILL PASS THE USP TEST)";
%MEND PRTCUSP1;

%MACRO EVCUSP1;

DATA _NULL_; WINDOW SMAIN COLOR=GREY
#1 "CONTENT UNIFORMITY ACCEPTANCE LIMIT PROGRAM" C=yellow
#2 "FOR SAMPLING PLAN 1 (ONE SAMPLE PER LOCATION)" C=yellow
#4 "TO EVALUATE LIMITS, THE USER MUST SPECIFY THE RANGE OF" C=yellow
#5 "POSSIBLE POPULATION VALUES FOR THE MEAN AND CV" C=yellow
#6 "ENTER ALL VALUES AS POSITIVE INTEGERS" C=yellow
#8  "ENTER LOWER BOUND FOR MEAN: " C=BLUE ULOW 4.0 A=UNDERLINE
#9  "ENTER UPPER BOUND FOR MEAN: " C=BLUE UHIGH 4.0  A=UNDERLINE
#10 "ENTER INCREMENT FOR MEAN:   " C=BLUE UINCRE 4.0 A=UNDERLINE
#11 "ENTER DIVISOR FOR MEAN:     " C=BLUE UDIV 4.0  A=UNDERLINE
#13 "ENTER LOWER BOUND FOR CV:   " C=BLUE CVLOW 4.0 A=UNDERLINE
#14 "ENTER UPPER BOUND FOR CV:   " C=BLUE CVHIGH 4.0 A=UNDERLINE
#15 "ENTER INCREMENT FOR CV:     " C=BLUE CVINCRE 4.0 A=UNDERLINE
#16 "ENTER DIVISOR FOR CV:       " C=BLUE CVDIV 4.0 A=UNDERLINE;
WINDOW PINT COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ALL VALUES MUST POSITIVE INTEGERS" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ORD  COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ERROR: UPPER BOUND IS LESS THAN LOWER BOUND" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
ULOW=950;
UHIGH=1000;
UINCRE=50;
UDIV=10;
CVLOW=10;
CVHIGH=40;
CVINCRE=30;
CVDIV=10;
SMAIN:
DISPLAY SMAIN BELL;
IF ULOW LT 1 OR ROUND(ULOW) NE ULOW
OR UHIGH LT 1 OR ROUND(UHIGH) NE UHIGH
OR UINCRE LT 1 OR ROUND(UINCRE) NE UINCRE
OR UDIV LT 1 OR ROUND(UDIV) NE UDIV
OR CVLOW LT 1 OR ROUND(CVLOW) NE CVLOW
OR CVHIGH LT 1 OR ROUND(CVHIGH) NE CVHIGH
OR CVINCRE LT 1 OR ROUND(CVINCRE) NE CVINCRE
OR CVDIV LT 1 OR ROUND(CVDIV) NE CVDIV
THEN DO;
DISPLAY PINT;
GOTO SMAIN;
END;
IF ULOW GT UHIGH
OR CVLOW GT CVHIGH
THEN DO;
DISPLAY ORD;
GOTO SMAIN;
END;
CALL SYMPUT("ULOW",PUT(ULOW,4.0));
CALL SYMPUT("UHIGH",PUT(UHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(UINCRE,4.0));
CALL SYMPUT("UDIV",PUT(UDIV,4.0));
CALL SYMPUT("CVLOW",PUT(CVLOW,4.0));
CALL SYMPUT("CVHIGH",PUT(CVHIGH,4.0));
CALL SYMPUT("CVINCRE",PUT(CVINCRE,4.0));
CALL SYMPUT("CVDIV",PUT(CVDIV,4.0)); STOP;
RUN;

DATA TAB;
      SET SEVEN;

%MACRO DSCUSP1;
   %DO I = 1 %TO 6;
      DATA DATA&I;
         SET TAB;
         STD = X&I * CV&I / 100; RENAME X&I = X;
         KEEP X&I STD;
   %END;

%MEND DSCUSP1;

%DSCUSP1

DATA ONE;
   SET DATA1 DATA2 DATA3 DATA4 DATA5 DATA6;
   N = &NUMBER;

%MACRO SIGCUSP1;

   %DO CV = &CVLOW %TO &CVHIGH %BY &CVINCRE;
      %DO U = &ULOW %TO &UHIGH %BY &UINCRE;

         DATA SAVE;
            SET ONE END = LAST;
            U = &U / &UDIV;
            CV = &CV / &CVDIV;
            SIGMA = U * CV / 100;
            PMEAN = PROBNORM((x - U) * SQRT(N) / SIGMA)
                    - PROBNORM((LAG(X) - U) * SQRT(N) / SIGMA);
            AVEHT = (STD + LAG(STD)) / 2;
            PSTD = PROBCHI((N - 1) * AVEHT * AVEHT
                   / ( SIGMA * SIGMA), N - 1);
            PT = PMEAN * PSTD ;
            PTRAP + PT;
            IF LAST THEN OUTPUT;
         RUN;

PROC APPEND BASE = SAVEALL DATA = SAVE;

       %END;
    %END;

%MEND SIGCUSP1;

%SIGCUSP1

OPTIONS NODATE NONUMBER;
PROC PRINT DATA = SAVEALL split = '*';
   label ptrap = 'PROBABILITY*OF*PASSING';
   VAR CV PTRAP;
   ID U;
TITLE1 "ACCEPTANCE LIMIT TABLE FOR &FORM CONTENT UNIFORMITY(N=&NUMBER)";
TITLE2 "SAMPLING PLAN 1";
TITLE3 'DETERMINE PROBABILITY OF PASSING ACCEPTANCE LIMIT TABLE';
TITLE4 "CONFIDENCE LEVEL = &CILEVEL AND LOWER BOUND = &LBOUND";
RUN;
%MEND EVCUSP1;

%MACRO SMPCUSP1;

DATA _NULL_; WINDOW TMAIN COLOR=GREY
#1 "CONTENT UNIFORMITY ACCEPTANCE LIMIT PROGRAM" C=yellow
#2 "FOR SAMPLING PLAN 1 (ONE SAMPLE PER LOCATION)" C=yellow
#4 "TO DETERMINE LOWER BOUND FOR FOUND SAMPLE RESULTS" C=yellow
#6  "ENTER SAMPLE MEAN (% CLAIM): " C=BLUE MEAN 6.3 A=UNDERLINE
#7  "ENTER SAMPLE CV (%):         " C=BLUE CV 6.3 A=UNDERLINE;
WINDOW LTZ COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "CV MUST BE NON NEGATIVE" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW RANGE COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "MEAN MUST BE BETWEEN 85.1 AND 114.9" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
MEAN= 100.00;
CV=4.00;
TMAIN:
DISPLAY TMAIN BELL;
IF CV LE 0 THEN DO;
DISPLAY LTZ;
GOTO TMAIN;
END;
IF MEAN LT 85.1 OR MEAN GT 114.9 THEN DO;
DISPLAY RANGE;
GOTO TMAIN;
END;
CALL SYMPUT("MEAN",PUT(MEAN,6.3));
CALL SYMPUT("CV",PUT(CV,6.3)); STOP;
RUN;

DATA TAB;
LENGTH TYPE $1;
LABEL OVERBD = 'OVERALL LOWER BOUND'
       MEAN = 'SAMPLE MEAN(%CLAIM)';
   CILEVEL = &CILEVEL;
   TYPE = "&FORM";
   Z = PROBIT((1 + SQRT(&CILEVEL / 100)) / 2);
   N = &NUMBER;
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
      MEAN = &MEAN;
      CV = &CV;
      SAMPSD= &MEAN * CV/100;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEAN - Z *SIGMA / SQRT(N);
    ULU = MEAN + Z * SIGMA / SQRT(N);
%c1calc

OPTIONS NODATE NONUMBER;
PROC PRINT SPLIT = '*';
  LABEL SAMPSD = 'SAMPLE*STD DEV*(% CLAIM)'
        MEAN = 'SAMPLE* MEAN*(% CLAIM)'
        OVERBD = 'LOWER BOUND';

  ID MEAN;
  VAR SAMPSD CV OVERBD;
TITLE1 "ACCEPTANCE LIMIT TABLE FOR &FORM CONTENT UNIFORMITY(N=&NUMBER)";
TITLE2 "SAMPLING PLAN 1";
TITLE3 'DETERMINE PROBABILITY OF FUTURE SAMPLES PASSING THE USP TEST';
TITLE4 "WITH &CILEVEL ASSURANCE FOR GIVEN SAMPLE MEAN AND CV";
run;
%MEND SMPCUSP1;

%MACRO ANACUSP1;
    %wincusp1;
%IF %UPCASE(&A1CUSP1)=Y OR %UPCASE(&A2CUSP1)=Y %THEN %DO;
     %CALCUSP1;
    %END;
%IF %UPCASE(&A1CUSP1)=Y %THEN %DO;
      %PRTCUSP1;
    %END;
%IF %UPCASE(&A2CUSP1)=Y %THEN %DO;
      %EVCUSP1;
PROC DATASETS LIBRARY = WORK;
   DELETE SAVEALL;
    %END;
%IF %UPCASE(&A3CUSP1)=Y %THEN %DO;
      %SMPCUSP1;
    %END;
%MEND ANACUSP1;

%ANACUSP1

RUN;
%MEND CUSP1;
%CUSP1
